Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90	(revision 2620)
@@ -4,7 +4,7 @@
    !! Ocean forcing:  read input field for surface boundary condition
    !!=====================================================================
-   !! History :  9.0  !  06-06  (G. Madec) Original code
-   !!                 !  05-08  (S. Alderson) Modified for Interpolation in memory
-   !!                 !         from input grid to model grid
+   !! History :  2.0  !  06-2006  (S. Masson, G. Madec) Original code
+   !!                 !  05-2008  (S. Alderson) Modified for Interpolation in memory
+   !!                 !                         from input grid to model grid
    !!----------------------------------------------------------------------
 
@@ -33,6 +33,6 @@
       CHARACTER(len = 34)  ::   wname       ! generic name of a NetCDF weights file to be used, blank if not
       CHARACTER(len = 34)  ::   vcomp       ! symbolic component name if a vector that needs rotation
-                                            ! a string starting with "U" or "V" for each component   
-                                            ! chars 2 onwards identify which components go together  
+      !                                     ! a string starting with "U" or "V" for each component   
+      !                                     ! chars 2 onwards identify which components go together  
    END TYPE FLD_N
 
@@ -51,5 +51,5 @@
       REAL(wp) , ALLOCATABLE, DIMENSION(:,:,:,:) ::   fdta       ! 2 consecutive record of input fields
       CHARACTER(len = 256)            ::   wgtname      ! current name of the NetCDF weight file acting as a key
-                                                        ! into the WGTLIST structure
+      !                                                 ! into the WGTLIST structure
       CHARACTER(len = 34)             ::   vcomp        ! symbolic name for a vector component that needs rotation
       LOGICAL                         ::   rotn         ! flag to indicate whether field has been rotated
@@ -65,5 +65,5 @@
       INTEGER , DIMENSION(2)                  ::   ddims        ! shape of input grid
       INTEGER , DIMENSION(2)                  ::   botleft      ! top left corner of box in input grid containing 
-                                                                ! current processor grid
+      !                                                         ! current processor grid
       INTEGER , DIMENSION(2)                  ::   topright     ! top right corner of box 
       INTEGER                                 ::   jpiwgt       ! width of box on input grid
@@ -72,6 +72,6 @@
       INTEGER                                 ::   nestid       ! for agrif, keep track of nest we're in
       INTEGER                                 ::   overlap      ! =0 when cyclic grid has no overlapping EW columns
-                                                                ! =>1 when they have one or more overlapping columns      
-                                                                ! =-1 not cyclic
+      !                                                         ! =>1 when they have one or more overlapping columns      
+      !                                                         ! =-1 not cyclic
       LOGICAL                                 ::   cyclic       ! east-west cyclic or not
       INTEGER,  DIMENSION(:,:,:), POINTER     ::   data_jpi     ! array of source integers
@@ -93,7 +93,6 @@
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -259,6 +258,4 @@
       !! ** Purpose :  - if time interpolation, read before data 
       !!               - open current year file
-      !!
-      !! ** Method  :   
       !!----------------------------------------------------------------------
       INTEGER  , INTENT(in   ) ::   kn_fsbc   ! sbc computation period (in time step) 
@@ -408,6 +405,4 @@
       !!                  nrec_a(1): record number
       !!                  nrec_b(2) and nrec_a(2): time of the beginning and end of the record (for print only)
-      !!
-      !! ** Method  :   
       !!----------------------------------------------------------------------
       INTEGER  , INTENT(in   )           ::   kn_fsbc   ! sbc computation period (in time step) 
@@ -555,11 +550,9 @@
       !!
       !! ** Purpose :   read the data
-      !!
-      !! ** Method  :   
-      !!----------------------------------------------------------------------
-      TYPE(FLD), INTENT(inout)   ::   sdjf   ! input field related variables
-      !!
-      INTEGER                    ::   ipk    ! number of vertical levels of sdjf%fdta ( 2D: ipk=1 ; 3D: ipk=jpk )
-      INTEGER                    ::   iw     ! index into wgts array
+      !!----------------------------------------------------------------------
+      TYPE(FLD), INTENT(inout) ::   sdjf   ! input field related variables
+      !!
+      INTEGER                  ::   ipk    ! number of vertical levels of sdjf%fdta ( 2D: ipk=1 ; 3D: ipk=jpk )
+      INTEGER                  ::   iw     ! index into wgts array
       !!---------------------------------------------------------------------
             
@@ -593,9 +586,7 @@
       !!
       !! ** Purpose :   Vector fields may need to be rotated onto the local grid direction
-      !!
-      !! ** Method  :   
       !!----------------------------------------------------------------------
       USE wrk_nemo, ONLY: wrk_use, wrk_release
-      USE wrk_nemo, ONLY: utmp => wrk_2d_4, vtmp => wrk_2d_5
+      USE wrk_nemo, ONLY: utmp => wrk_2d_4, vtmp => wrk_2d_5      ! 2D workspace
       !!
       INTEGER  , INTENT(in   )               ::   kt        ! ocean time step
@@ -609,7 +600,6 @@
       !!---------------------------------------------------------------------
 
-      IF(.not. wrk_use(2, 4,5))THEN
-         CALL ctl_stop('fld_rot: ERROR: requested workspace arrays are unavailable.')
-         RETURN
+      IF(.not. wrk_use(2, 4,5) ) THEN
+         CALL ctl_stop('fld_rot: ERROR: requested workspace arrays are unavailable.')   ;   RETURN
       END IF
 
@@ -646,9 +636,7 @@
           ENDIF
        END DO
-
-      IF(.not. wrk_release(2, 4,5))THEN
-         CALL ctl_stop('fld_rot: ERROR: failed to release workspace arrays.')
-      END IF
-
+      !
+      IF(.not. wrk_release(2, 4,5) )    CALL ctl_stop('fld_rot: ERROR: failed to release workspace arrays.')
+      !
    END SUBROUTINE fld_rot
 
@@ -659,12 +647,11 @@
       !!
       !! ** Purpose :   update the file name and open the file
-      !!
-      !! ** Method  :   
-      !!----------------------------------------------------------------------
-      TYPE(FLD), INTENT(inout)           ::   sdjf                  ! input field related variables
-      INTEGER  , INTENT(in   )           ::   kyear                 ! year value
-      INTEGER  , INTENT(in   )           ::   kmonth                ! month value
-      INTEGER  , INTENT(in   )           ::   kday                  ! day value
-      LOGICAL  , INTENT(in   ), OPTIONAL ::   ldstop                ! stop if open to read a non-existing file (default = .TRUE.)
+      !!----------------------------------------------------------------------
+      TYPE(FLD)        , INTENT(inout) ::   sdjf     ! input field related variables
+      INTEGER          , INTENT(in   ) ::   kyear    ! year value
+      INTEGER          , INTENT(in   ) ::   kmonth   ! month value
+      INTEGER          , INTENT(in   ) ::   kday     ! day value
+      LOGICAL, OPTIONAL, INTENT(in   ) ::   ldstop   ! stop if open to read a non-existing file (default = .TRUE.)
+      !!----------------------------------------------------------------------
 
       IF( sdjf%num /= 0 )   CALL iom_close( sdjf%num )   ! close file if already open
@@ -693,6 +680,4 @@
       !!
       !! ** Purpose :   fill sdf with sdf_n and control print
-      !!
-      !! ** Method  :   
       !!----------------------------------------------------------------------
       TYPE(FLD)  , DIMENSION(:), INTENT(inout) ::   sdf        ! structure of input fields (file informations, fields read)
@@ -748,13 +733,10 @@
       !!                if it is a new entry, the weights data is read in and
       !!                restructured (fld_weight)
-      !!
-      !! ** Method  :   
-      !!----------------------------------------------------------------------
-      TYPE( FLD ),      INTENT(in)    ::   sd        ! field with name of weights file
-      INTEGER,      INTENT(inout)     ::   kwgt      ! index of weights
-      !!
-      INTEGER                         ::   kw
-      INTEGER                         ::   nestid
-      LOGICAL                         ::   found
+      !!----------------------------------------------------------------------
+      TYPE( FLD ), INTENT(in   ) ::   sd        ! field with name of weights file
+      INTEGER    , INTENT(inout) ::   kwgt      ! index of weights
+      !!
+      INTEGER ::   kw, nestid   ! local integer
+      LOGICAL ::   found        ! local logical
       !!----------------------------------------------------------------------
       !
@@ -782,7 +764,8 @@
          CALL fld_weight( sd )
       ENDIF
-
+      !
    END SUBROUTINE wgt_list
 
+
    SUBROUTINE wgt_print( )
       !!---------------------------------------------------------------------
@@ -790,12 +773,8 @@
       !!
       !! ** Purpose :   print the list of known weights
-      !!
-      !! ** Method  :   
-      !!----------------------------------------------------------------------
-      !!
-      INTEGER                         ::   kw
-      !!----------------------------------------------------------------------
-      !
-
+      !!----------------------------------------------------------------------
+      INTEGER ::   kw   !
+      !!----------------------------------------------------------------------
+      !
       DO kw = 1, nxt_wgt-1
          WRITE(numout,*) 'weight file:  ',TRIM(ref_wgts(kw)%wgtname)
@@ -814,6 +793,7 @@
          IF( ASSOCIATED(ref_wgts(kw)%data_wgt) )  WRITE(numout,*) '       allocated'
       END DO
-
+      !
    END SUBROUTINE wgt_print
+
 
    SUBROUTINE fld_weight( sd )
@@ -823,6 +803,4 @@
       !! ** Purpose :   create a new WGT structure and fill in data from  
       !!                file, restructuring as required
-      !!
-      !! ** Method  :   
       !!----------------------------------------------------------------------
       USE wrk_nemo, ONLY: wrk_use, wrk_release, iwrk_use, iwrk_release
@@ -830,19 +808,18 @@
       USE wrk_nemo, ONLY: data_src => iwrk_2d_1
       !!
-      TYPE( FLD ),      INTENT(in)            ::   sd            ! field with name of weights file
-      !!
-      INTEGER                                 ::   jn            ! dummy loop indices
-      INTEGER                                 ::   inum          ! temporary logical unit
-      INTEGER                                 ::   id            ! temporary variable id
-      INTEGER                                 ::   ipk           ! temporary vertical dimension
-      CHARACTER (len=5)                       ::   aname
-      INTEGER , DIMENSION(3)                  ::   ddims
-      LOGICAL                                 ::   cyclical
-      INTEGER                                 ::   zwrap         ! temporary integer
-      !!----------------------------------------------------------------------
-      !
-      IF( (.NOT. wrk_use(2, 1)) .OR. (.NOT. iwrk_use(2,1)) )THEN
-         CALL ctl_stop('fld_weights: requested workspace arrays are unavailable.')
-         RETURN
+      TYPE( FLD ), INTENT(in) ::   sd   ! field with name of weights file
+      !!
+      INTEGER                ::   jn            ! dummy loop indices
+      INTEGER                ::   inum          ! temporary logical unit
+      INTEGER                ::   id            ! temporary variable id
+      INTEGER                ::   ipk           ! temporary vertical dimension
+      CHARACTER (len=5)      ::   aname
+      INTEGER , DIMENSION(3) ::   ddims
+      LOGICAL                ::   cyclical
+      INTEGER                ::   zwrap      ! local integer
+      !!----------------------------------------------------------------------
+      !
+      IF(  .NOT. wrk_use(2, 1)  .OR.  .NOT. iwrk_use(2,1)  ) THEN
+         CALL ctl_stop('fld_weights: requested workspace arrays are unavailable.')   ;   RETURN
       END IF
       !
@@ -957,11 +934,11 @@
       ENDIF
 
-      IF( (.NOT. wrk_release(2, 1)) .OR. (.NOT. iwrk_release(2,1)) )THEN
-         CALL ctl_stop('fld_weights: failed to release workspace arrays.')
-      END IF
-
+      IF( .NOT. wrk_release(2, 1) .OR.    &
+          .NOT.iwrk_release(2, 1)   )   CALL ctl_stop('fld_weights: failed to release workspace arrays')
+      !
    END SUBROUTINE fld_weight
 
-   SUBROUTINE fld_interp(num, clvar, kw, kk, dta, nrec)
+
+   SUBROUTINE fld_interp( num, clvar, kw, kk, dta, nrec )
       !!---------------------------------------------------------------------
       !!                    ***  ROUTINE fld_interp  ***
@@ -969,23 +946,20 @@
       !! ** Purpose :   apply weights to input gridded data to create data
       !!                on model grid
-      !!
-      !! ** Method  :   
-      !!----------------------------------------------------------------------
-      INTEGER,          INTENT(in)                        ::   num                 ! stream number
-      CHARACTER(LEN=*), INTENT(in)                        ::   clvar               ! variable name
-      INTEGER,          INTENT(in)                        ::   kw                  ! weights number
-      INTEGER,          INTENT(in)                        ::   kk                  ! vertical dimension of kk
-      REAL(wp),         INTENT(inout), DIMENSION(:,:,:)   ::   dta              ! output field on model grid
-      INTEGER,          INTENT(in)                        ::   nrec                ! record number to read (ie time slice)
+      !!----------------------------------------------------------------------
+      INTEGER                   , INTENT(in   ) ::   num     ! stream number
+      CHARACTER(LEN=*)          , INTENT(in   ) ::   clvar   ! variable name
+      INTEGER                   , INTENT(in   ) ::   kw      ! weights number
+      INTEGER                   , INTENT(in   ) ::   kk      ! vertical dimension of kk
+      REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::   dta     ! output field on model grid
+      INTEGER                   , INTENT(in   ) ::   nrec    ! record number to read (ie time slice)
       !! 
-      INTEGER, DIMENSION(3)                               ::   rec1,recn           ! temporary arrays for start and length
-      INTEGER                                             ::  jk, jn, jm           ! loop counters
-      INTEGER                                             ::  ni, nj               ! lengths
-      INTEGER                                             ::  jpimin,jpiwid        ! temporary indices
-      INTEGER                                             ::  jpjmin,jpjwid        ! temporary indices
-      INTEGER                                             ::  jpi1,jpi2,jpj1,jpj2  ! temporary indices
-      !!----------------------------------------------------------------------
-      !
-
+      INTEGER, DIMENSION(3) ::   rec1,recn   ! temporary arrays for start and length
+      INTEGER ::  jk, jn, jm           ! loop counters
+      INTEGER ::  ni, nj               ! lengths
+      INTEGER ::  jpimin,jpiwid        ! temporary indices
+      INTEGER ::  jpjmin,jpjwid        ! temporary indices
+      INTEGER ::  jpi1,jpi2,jpj1,jpj2  ! temporary indices
+      !!----------------------------------------------------------------------
+      !
       !! for weighted interpolation we have weights at four corners of a box surrounding 
       !! a model grid point, each weight is multiplied by a grid value (bilinear case)
@@ -1107,19 +1081,19 @@
         END DO
 
-        ! gradient in the ij direction
-        DO jk = 1,4
-          DO jn = 1, jpj
-            DO jm = 1,jpi
-              ni = ref_wgts(kw)%data_jpi(jm,jn,jk)
-              nj = ref_wgts(kw)%data_jpj(jm,jn,jk)
-              dta(jm,jn,:) = dta(jm,jn,:) + ref_wgts(kw)%data_wgt(jm,jn,jk+12) * 0.25 * ( &
+         ! gradient in the ij direction
+         DO jk = 1,4
+            DO jn = 1, jpj
+               DO jm = 1,jpi
+                  ni = ref_wgts(kw)%data_jpi(jm,jn,jk)
+                  nj = ref_wgts(kw)%data_jpj(jm,jn,jk)
+                  dta(jm,jn,:) = dta(jm,jn,:) + ref_wgts(kw)%data_wgt(jm,jn,jk+12) * 0.25 * ( &
                                (ref_wgts(kw)%fly_dta(ni+2,nj+2,:) - ref_wgts(kw)%fly_dta(ni  ,nj+2,:)) -   &
                                (ref_wgts(kw)%fly_dta(ni+2,nj  ,:) - ref_wgts(kw)%fly_dta(ni  ,nj  ,:)))
+               END DO
             END DO
-          END DO
-        END DO
-
+         END DO
+         !
       END IF
-
+      !
    END SUBROUTINE fld_interp
 
@@ -1130,6 +1104,4 @@
       !!
       !! ** Purpose :  
-      !!
-      !! ** Method  :
       !!---------------------------------------------------------------------
       CHARACTER(len=*), INTENT(in)   ::   cdday   !3 first letters of the first day of the weekly file
@@ -1143,5 +1115,5 @@
       DO ijul = 1, 7
          IF( cl_week(ijul) == TRIM(cdday) ) EXIT
-      ENDDO
+      END DO
       IF( ijul .GT. 7 )   CALL ctl_stop( 'ksec_week: wrong day for sdjf%cltype(6:8): '//TRIM(cdday) )
       !
@@ -1153,4 +1125,4 @@
    END FUNCTION ksec_week
 
-
+   !!======================================================================
 END MODULE fldread
